Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IClassificationBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IClassificationBenchmarkProblemDataGenerator.cs	(revision 7337)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IClassificationBenchmarkProblemDataGenerator.cs	(revision 7485)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IDiscriminantFunctionClassificationSolution.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IDiscriminantFunctionClassificationSolution.cs	(revision 7337)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Classification/IDiscriminantFunctionClassificationSolution.cs	(revision 7485)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 namespace HeuristicLab.Problems.DataAnalysis {
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Clustering/IClusteringBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Clustering/IClusteringBenchmarkProblemDataGenerator.cs	(revision 7337)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Clustering/IClusteringBenchmarkProblemDataGenerator.cs	(revision 7485)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisBenchmarkProblemDataGenerator.cs	(revision 7337)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataAnalysisBenchmarkProblemDataGenerator.cs	(revision 7485)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionBenchmarkProblemDataGenerator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionBenchmarkProblemDataGenerator.cs	(revision 7337)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/Regression/IRegressionBenchmarkProblemDataGenerator.cs	(revision 7485)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/NormalizedGiniCalculator.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/NormalizedGiniCalculator.cs	(revision 7337)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/NormalizedGiniCalculator.cs	(revision 7485)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Problems.DataAnalysis {