Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/LightweightApplicationManager.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/LightweightApplicationManager.cs	(revision 7502)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/LightweightApplicationManager.cs	(revision 7520)
@@ -75,6 +75,5 @@
       foreach (Type t in GetTypes(type)) {
         object instance = null;
-        try { instance = Activator.CreateInstance(t); }
-        catch { }
+        try { instance = Activator.CreateInstance(t); } catch { }
         if (instance != null) instances.Add(instance);
       }
@@ -127,8 +126,8 @@
 
         var buildTypes = from t in assembly.GetTypes()
+                         where CheckTypeCompatibility(type, t)
                          where !IsNonDiscoverableType(t)
                          where onlyInstantiable == false ||
                                (!t.IsAbstract && !t.IsInterface && !t.HasElementType)
-                         where CheckTypeCompatibility(type, t)
                          select BuildType(t, type);
 
@@ -136,9 +135,7 @@
                where includeGenericTypeDefinitions || !t.IsGenericTypeDefinition
                select t;
-      }
-      catch (TypeLoadException) {
+      } catch (TypeLoadException) {
         return Enumerable.Empty<Type>();
-      }
-      catch (ReflectionTypeLoadException) {
+      } catch (ReflectionTypeLoadException) {
         return Enumerable.Empty<Type>();
       }
@@ -174,6 +171,5 @@
           if (type.IsAssignableFrom(otherGenericTypeDefinition.MakeGenericType(typeGenericArguments)))
             return true;
-        }
-        catch (Exception) { }
+        } catch (Exception) { }
       }
       return false;
Index: trunk/sources/HeuristicLab.PluginInfrastructure/3.3/SandboxApplicationManager.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/3.3/SandboxApplicationManager.cs	(revision 7502)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/3.3/SandboxApplicationManager.cs	(revision 7520)
@@ -119,6 +119,5 @@
       try {
         runnablePlugin.Run();
-      }
-      finally {
+      } finally {
         // unload plugins in reverse order
         foreach (var plugin in loadedPlugins.Reverse<IPlugin>()) {
@@ -150,6 +149,5 @@
       foreach (Type t in GetTypes(typeof(T), plugin, onlyInstantiable: true, includeGenericTypeDefinitions: false)) {
         T instance = null;
-        try { instance = (T)Activator.CreateInstance(t); }
-        catch { }
+        try { instance = (T)Activator.CreateInstance(t); } catch { }
         if (instance != null) instances.Add(instance);
       }
@@ -166,6 +164,5 @@
       foreach (Type t in GetTypes(typeof(T), asm, onlyInstantiable: true, includeGenericTypeDefinitions: false)) {
         T instance = null;
-        try { instance = (T)Activator.CreateInstance(t); }
-        catch { }
+        try { instance = (T)Activator.CreateInstance(t); } catch { }
         if (instance != null) instances.Add(instance);
       }
@@ -191,6 +188,5 @@
       foreach (Type t in GetTypes(type, onlyInstantiable: true, includeGenericTypeDefinitions: false)) {
         object instance = null;
-        try { instance = Activator.CreateInstance(t); }
-        catch { }
+        try { instance = Activator.CreateInstance(t); } catch { }
         if (instance != null) instances.Add(instance);
       }
@@ -262,8 +258,8 @@
     private static IEnumerable<Type> GetTypes(Type type, Assembly assembly, bool onlyInstantiable, bool includeGenericTypeDefinitions) {
       var buildTypes = from t in assembly.GetTypes()
+                       where CheckTypeCompatibility(type, t)
                        where !IsNonDiscoverableType(t)
                        where onlyInstantiable == false ||
                              (!t.IsAbstract && !t.IsInterface && !t.HasElementType)
-                       where CheckTypeCompatibility(type, t)
                        select BuildType(t, type);
 
@@ -303,6 +299,5 @@
           if (type.IsAssignableFrom(otherGenericTypeDefinition.MakeGenericType(typeGenericArguments)))
             return true;
-        }
-        catch (Exception) { }
+        } catch (Exception) { }
       }
       return false;